/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
/* $id$ */

#ifndef OS_WIN32
  #include <config.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifndef OS_WIN32
#include <sys/time.h>
#include <unistd.h>
#endif
#include <sys/types.h>
#include <math.h>
#define DEFINECONSTANTS
#include "wuerfel.h"

int main(int argc, char **argv) {

    ident ();
    // usage ();

    glutInit (&argc, argv);

    setoptiondefaults ();

    getoptions (argc, argv);

    berechnewg();

    if (options.print) {
        printf ("Datenfiles wurden erstellet, sie enthalten %d Positionen des Wrfelgrtels\n",
                anzelt);
    }
    else {
        control ();
        owgp = wg;
        zeichnewg();
    }

    freewg();

    return 0;
}

void
ident (void) {
#ifdef OS_WIN32
    fprintf (stderr, "Der umstuelpbare Wuerfel nach Paul Schatz, Version: 3.5.5\n");
#else
    fprintf (stderr, "Der umstuelpbare Wuerfel nach Paul Schatz, Version: %s\n", VERSION);
#endif
    fprintf (stderr, "(C) 2004 Franz Zahaurek <http://www.fzk.at>\n");
}

void
usage (void) {
    fprintf (stderr, "\n");
    fprintf (stderr, "Optionen: -a     Achsen darstellen\n");
    fprintf (stderr, "          -b     Berhrungslinie Wrfelgrtel/Timeform ausgeben, Default nein\n");
    fprintf (stderr, "          -d #   Delta Winkelschrittweite, Default=6\n");
    fprintf (stderr, "          -e     Erzeugende Linien von Oloid/Kuboid, Default=ja\n");
    fprintf (stderr, "          -f     Koordinaten der Punkte ausgeben, dann exit\n");
    fprintf (stderr, "          -g     Gittermodell darstellen, Default=nein\n");
    fprintf (stderr, "          -h     Hilfetext ausgeben\n");
    fprintf (stderr, "          -i     Info verbergen, Default=zeigen\n");
    fprintf (stderr, "          -k     Kuboid darstellen, Default=nein\n");
    fprintf (stderr, "          -l     Labels darstellen, Default=nein\n");
    fprintf (stderr, "          -m #   Animationsmodus, Default=1\n");
    fprintf (stderr, "                     1...Hauptdiagonale fixiert\n");
    fprintf (stderr, "                     2...Scharnierkante fixiert\n");
    fprintf (stderr, "                     3...Element fixiert\n");
    fprintf (stderr, "          -o     Oloid darstellen, Default=nein\n");
    fprintf (stderr, "          -p #   bei dieser Positionsnummer starten und halten \n");
    fprintf (stderr, "          -s #   Breite des Fensters in Pixeln, Default=800\n");
    fprintf (stderr, "          -t     Wuerfelguertel schwebt, Default=nein\n");
    fprintf (stderr, "          -v     Virtuelle Ecken darstellen, Default=nein\n");
    fprintf (stderr, "          -w     Wuerfelguertel darstellen, ist Default\n");
}

void
control (void) {
    fprintf (stderr, "\n");
    fprintf (stderr, "Steuerung mit der Maus:\n\n");
    fprintf (stderr, "  Rechte_Maustaste        Kontextmenue\n\n");
    fprintf (stderr, "\n");
    fprintf (stderr, "Steuerung mit Hot-Keys:\n\n");
    fprintf (stderr, "  a            Toggle: Achsen zeigen/verbergen\n");
    fprintf (stderr, "  b            Toggle: Berhrungslinie ein/aus\n");
    fprintf (stderr, "  e            Toggle: Erzeugende von Oloid/Kuboid ein/aus\n");
    fprintf (stderr, "  g            Toggle: Gitter-/Flaechendarstellung\n");
    fprintf (stderr, "  i            Toggle: Info ein/aus\n");
    fprintf (stderr, "  k            Toggle: Kuboid ein/aus\n");
    fprintf (stderr, "  l            Toggle: Labels ein/aus\n");
    fprintf (stderr, "  o            Toggle: Oloid ein/aus\n");
    fprintf (stderr, "  p            Toggle: Projektion perspektivisch/parallel\n");
    fprintf (stderr, "  s            Toggle: start/stopp\n");
    fprintf (stderr, "  t            Toggle: Schweben ein/aus\n");
    fprintf (stderr, "  v            Toggle: Virtuelle Ecken zeigen/verbergen\n");
    fprintf (stderr, "  w            Toggle: Wuerfelguertel ein/aus\n");
    fprintf (stderr, "  x/y/z        Drehung um die x/y/z-Achse\n");
    fprintf (stderr, "  -/+          schneller/langsamer drehen\n");
    fprintf (stderr, "  ./,          Naechste/vorherige Position\n");
    fprintf (stderr, "  1/2/3        Drehmodus: Diagonale/Scharnier/Element fxiert\n");
    fprintf (stderr, "  <HOME>       Drehung um x/y/z-Achse auf 0 stellen\n");
    fprintf (stderr, "  Pfeiltasten  Verschieben in x/y Richtung\n");
    fprintf (stderr, "  <PAGE_UP>,<PAGE_DOWN>  Verschieben in z Richtung\n");
    fprintf (stderr, "  <ESC>,q      Quit\n\n");
}

#ifdef OS_WIN32
void
warten (int sec) {
	return;
}


#else
void
warten (int sec){
    fd_set rfds;
    struct timeval tv;

    /* Watch stdin (fd 0) to see when it has input. */
    FD_ZERO(&rfds);
    FD_SET(0, &rfds);

    /* Wait up to sec seconds. */
    tv.tv_sec = sec;
    tv.tv_usec = 0;

    select(1, &rfds, NULL, NULL, &tv);
}
#endif

#ifdef OS_WIN32
/*
** Der Algorithmus zur Abarbeitung von Optionen entstammt dem Buch:
** A.T.Schreiner: System-Programmierung in UNIX, Teil 1: Werkzeuge
** Seite 136 ff
** Verlag: B.G. Teubner Stuttgart 1984
**
** Anmerkung: Man beachte die Konstruktionen: **++argv und *++*argv
*/
#define LOW  'a'
#define HIGH 'z'
#define VAL(x) vals[(x) - LOW]
static int vals[HIGH - LOW + 1];
void
getoptions (int argc, char **argv) {

    while (--argc) {
	char i;

	if (**++argv == '-') {

	    switch (i = *++*argv) {
	    case 0:
		/* alleinstehendes Minus wird ebergangen */
		fprintf (stderr, "einsames Minus wird berlesen\n");
		continue ;
	    case 'd':
	    case 'm':
	    case 'p':
	    case 's':
		if (*++*argv) {
		    VAL (i) = atoi (*argv);
/* 		    fprintf (stderr, "Wert %c = %d\n", i, VAL(i)); */
		}
		else if (-- argc) {
		    VAL (i) = atoi (*++argv);
/* 		    fprintf (stderr, "Wert %c = %d\n", i, VAL(i)); */
		}
		else {
		    /* Wert zur Option fehlt */
		    fprintf (stderr, "Wert zur Option %c fehlt\n", i);
		    exit (1);
		    break;
		}
		switch (i) {
		case 'd':
		    options.dw = TOBWINKEL((double) VAL (i));
		    break;
		case 'm':
		    options.mode = VAL (i);
		    if (options.mode < 1 || options.mode > 3) {
			options.mode = 1;
		    }
		    break;
		case 'p':
		    options.position = VAL (i);
		    break;
		case 's':
		    options.seite = VAL (i);
		    break;
		}
		continue;

	    case 'a':
		options.ach = TRUE;
		continue;

	    case 'b':
		options.touchline = TRUE;
		continue;

	    case 'e':
		options.erzeugende = FALSE;
		continue;

	    case 'f':
		options.print = TRUE;
		continue;

	    case 'g':
		options.lines = TRUE;
		polygonMode = GL_LINE;
		continue;

	    case 'h':
		usage ();
		exit (1);

	    case 'i':
		options.info = FALSE;
		continue;

	    case 'k':
        	if (! options.oloid) {
		  options.kuboid = TRUE;
		}
		else {
		  fprintf (stderr, "Option -k ignoriert, da Oloid gewhlt ist\n");
		}
		continue;

	    case 'o':
        	if (! options.kuboid) {
		  options.oloid = TRUE;
		}
		else {
		  fprintf (stderr, "Option -o ignoriert, da Kuboid gewhlt ist\n");
		}
		continue;

	    case 't':
		options.tork = TRUE;
		continue;

	    case 'l':
		options.labels = TRUE;
		continue;

	    case 'v':
		options.virtuell = TRUE;
		continue;

	    case 'w':
		options.wuerfel = FALSE;
		continue;

	    default:
		/* Unbekannte Option */
		fprintf (stderr, "A Option %c\n", i);
		exit (1);
		continue;
	    }
	    break;
	}
        else {
		fprintf (stderr, "Unbekanntes Argument %s\n", *argv);
		exit (1);
	}
    }
}
#else
/*
** Unter LINUX besser getopt() verwenden
*/

void
getoptions (int argc, char **argv) {
    int c;
    extern int optind;

    optind = 1;
    while (TRUE) {
        extern int opterr, optopt;
        opterr = 0;

        c = getopt (argc, argv, "abd:efghiklm:op:s:tvw");
/*      fprintf (stderr, "getopt: c=%d, opterr=%d, optopt=%c, optarg=%s\n", */
/*               c, opterr, optopt, optarg); */
        if ( c == -1) {
            break;
        }

        switch (c) {
        case -1:
            break;

        case 'a':
            options.ach = TRUE;
            break;

        case 'b':
            options.touchline = TRUE;
            break;

        case 'd':
            options.dw = TOBWINKEL((double)atoi (optarg));
            break;

        case 'e':
            options.erzeugende = FALSE;
            break;

        case 'g':
            options.lines = TRUE;
	    polygonMode = GL_LINE;
            break;

        case 'h':
            usage ();
            exit (1);

	case 'i':
	    options.info = FALSE;
	    break;

	case 'k':
            if (! options.oloid) {
	      options.kuboid = TRUE;
	    }
	    else {
	      fprintf (stderr, "Option -k ignoriert, da Oloid gewhlt ist\n");
	    }
	    break;

        case 'm':
            options.mode = atoi (optarg);
	    if (options.mode < 1 || options.mode > 3) {
		options.mode = 1;
	    }
            break;

	case 'o':
	    if (! options.kuboid) {
	      options.oloid = TRUE;
	    }
	    else {
	      fprintf (stderr, "Option -o ignoriert, da Kuboid gewhlt ist\n");
	    }
	    break;

        case 'p':
            options.position = atoi (optarg);
            break;

        case 'f':
            options.print = TRUE;
            break;

        case 's':
            options.seite = atoi (optarg);
            break;

        case 't':
            options.tork = TRUE;
            break;

        case 'v':
            options.virtuell = TRUE;
            break;

        case 'w':
	    options.wuerfel = FALSE;
            break;

        case 'l':
            options.labels = TRUE;
            break;

        default:
            fprintf (stderr, "\n");
            fprintf (stderr, "Falsche Option oder fehlerhaftes Optionsargument: <%c>\n", optopt);
            /* usage (); */
            exit (1);
        }
    }
}
#endif

void
setoptiondefaults (void) {
    options.dw = 2. * M_PI / 60.;  /* Default-Schrittweite 360/60=6 im Bogenmass */

    options.seite = 0;
    options.print = FALSE;
    options.virtuell = FALSE;
    options.ach = FALSE;

    options.lines = FALSE;
    polygonMode = GL_FILL;

    options.mode = 1;
    options.info = TRUE;
    options.tork = FALSE;
    options.perspektive = TRUE;
    options.labels = FALSE;
    options.kuboid = FALSE;
    options.oloid = FALSE;
    options.wuerfel = TRUE;
    options.touchline = FALSE;
    options.position = -1;
    options.erzeugende = TRUE;
}

void
freewg (void) {
    WG *wgp;

    wgp = wg;
    while (wgp) {
        WG *t;

        t = wgp;
        wgp = wgp->nextwgp;
        free (t);
    }
}
