/*
** Der umstlpbare Wrfel nach Paul Schatz
** (C) 1999,2004 Franz Zahaurek <http://www.fzk.at>
**
** Dieses Programm samt Dokumentation ist Freie Software und kann beliebig
** verwendet werden, soferne der obige Copyright-Vermerk nicht entfernt
** wird.
*/
#ifndef OS_WIN32
#include <config.h>
#include <sys/time.h>
#endif
#include <stdio.h>
#include <GL/glut.h>
#include <GL/gl.h>
#include "wuerfel.h"

void
WglKey (unsigned char key, int x, int y) {
    switch (key) {
    case 27: /* ESC */
    case 'q':
	exit (1);
    case '1':
    case '2':
    case '3':
/*     case '4': */
	WglSubMenuModus ((int)(key - '0'));
        break;
    case '.':
	WglNextPos ();
	break;
    case ',':
	WglPrevPos ();
	break;
    case 'g':
	WglToggleGitterFlaechen ();
	break;
    case 'a':
	WglToggleAxis ();
	break;
    case 'b':
	WglToggleTouchline ();
	break;
    case 'e':
	WglToggleErzeugende ();
	break;
    case 'v':
	WglToggleVirtuell ();
	break;
    case 'i':
        WglToggleInfo ();
	break;
    case 'k':
        WglToggleKuboid ();
	break;
    case 'o':
        WglToggleOloid ();
	break;
    case 'p':
	WglTogglePerspektive ();
	break;
    case 's':
	halt = !halt;
	break;
    case 't':
	WglToggleTorkeln ();
	break;
    case 'x':
	rotx += 1.;
	break;
    case 'y':
	roty += 1.;
	break;
    case 'z':
	rotz += 1.;
	break;
    case '+':
	WglSubMenuSpeed (1);
	break;
    case '-':
	WglSubMenuSpeed (2);
	break;
    case 'l':
        WglToggleLabels ();
	break;
    case 'w':
        WglToggleWuerfelguertel ();
	break;
    default:
	return;
    }
    WglPostRedisplay ();
}

void
WglSpecialKey (int key, int x, int y) {
    switch (key) {
    case GLUT_KEY_UP:
	trany += 0.1;
	break;
    case GLUT_KEY_DOWN:
	trany -= 0.1;
	break;
    case GLUT_KEY_LEFT:
	tranx -= 0.1;
	break;
    case GLUT_KEY_RIGHT:
	tranx += 0.1;
	break;
    case GLUT_KEY_PAGE_UP:
	tranz += 0.1;
	break;
    case GLUT_KEY_PAGE_DOWN:
	tranz -= 0.1;
	break;
    case GLUT_KEY_HOME:
	rotx = roty = rotz = tranx = trany = tranz = 0.;
	drotx = droty = drotz = dtranx = dtrany = dtranz = 0.;
	break;
    default:
	return;
    }
    WglPostRedisplay ();
}

void
WglCreateMenus (void) {
    /* Modus-Submenue */
    menIdMainSubModus = glutCreateMenu (WglSubMenuModus);
    glutAddMenuEntry ("<1> Hauptdiagonale fixiert", 1);
    glutAddMenuEntry ("<2> Scharnierkante fixiert", 2);
    glutAddMenuEntry ("<3> Element fixiert", 3);
/*     glutAddMenuEntry ("<4> Zentriert", 4); */

    /* Geschwindigkeit-Submenue */
    menIdMainSubSpeed = glutCreateMenu (WglSubMenuSpeed);
    glutAddMenuEntry ("<+> Schneller", 1);
    glutAddMenuEntry ("<-> Langsamer", 2);

    /* Create main menu for main window */
    menIdMain = glutCreateMenu (WglMainMenu);
    if (options.tork) {
        glutAddMenuEntry ("<t> Schweben aus", 1);
    }
    else {
        glutAddMenuEntry ("<t> Schweben ein", 1);
    }
    if (options.virtuell) {
        glutAddMenuEntry ("<v> Virtuelle Ecken aus", 2);
    }
    else {
        glutAddMenuEntry ("<v> Virtuelle Ecken ein", 2);
    }
    if (options.ach) {
        glutAddMenuEntry ("<a> Achsen aus", 3);
    }
    else {
        glutAddMenuEntry ("<a> Achsen ein", 3);
    }
    glutAddMenuEntry ("<p> Projektion orthogonal", 4);
    glutAddMenuEntry ("<g> Gitter", 5);
    if (options.labels) {
        glutAddMenuEntry ("<l> Labels aus", 6);
    }
    else {
        glutAddMenuEntry ("<l> Labels ein", 6);
    }
    if (options.kuboid) {
        glutAddMenuEntry ("<k> Kuboid aus", 7);
    }
    else {
        glutAddMenuEntry ("<k> Kuboid ein", 7);
    }
    if (options.oloid) {
        glutAddMenuEntry ("<o> Oloid aus", 8);
    }
    else {
        glutAddMenuEntry ("<o> Oloid ein", 8);
    }
    if (options.wuerfel) {
        glutAddMenuEntry ("<w> Wuerfelguertel aus", 9);
    }
    else {
        glutAddMenuEntry ("<w> Wuerfelguertel ein", 9);
    }
    if (options.touchline) {
        glutAddMenuEntry ("<b> Berhrungslinie aus", 10);
    }
    else {
        glutAddMenuEntry ("<b> Berhrungslinie ein", 10);
    }
    if (options.erzeugende) {
        glutAddMenuEntry ("<e> Erzeugende aus", 11);
    }
    else {
        glutAddMenuEntry ("<e> Erzeugende ein", 11);
    }
    if (options.info) {
        glutAddMenuEntry ("<i> Info aus", 12);
    }
    else {
        glutAddMenuEntry ("<i> Info ein", 12);
    }
    glutAddSubMenu ("Geschwindigkeit", menIdMainSubSpeed);
    glutAddSubMenu ("Modus", menIdMainSubModus);
    glutAddMenuEntry ("<q> Ende", 13);
    glutAttachMenu (GLUT_RIGHT_BUTTON);
}

void
WglSubMenuModus (int value) {
    switch (value) {
    case 1:
    case 2:
    case 3:
    case 4:
	options.mode = value;
	break;
    }
}

void
WglSubMenuSpeed (int value) {
fprintf (stderr, "Aktuelles Zeitintervall = %ld\n", waittime.tv_usec);
    switch (value) {
    case 1:
	waittime.tv_usec /= 2;
	break;
    case 2:
	if (waittime.tv_usec > 1000000) {
	    fprintf (stderr, "Zeitintervall bereits > 1 sek, Eingabe ignoriert\n");
	    return;
	}
        waittime.tv_usec *= 2;
	if (waittime.tv_usec == 0) {waittime.tv_usec = 1;}
	break;
    }
}

void
WglMainMenu(int value){

    switch(value){

    case 1:
	WglToggleTorkeln ();
	break;

    case 2:
	WglToggleVirtuell ();
	break;

    case 3:
	WglToggleAxis ();
	break;

    case 4:
	WglTogglePerspektive ();
	break;

    case 5:
	WglToggleGitterFlaechen ();
	break;

    case 6:
	WglToggleLabels ();
	break;

    case 7:
	WglToggleKuboid ();
	break;

    case 8:
	WglToggleOloid ();
	break;

    case 9:
	WglToggleWuerfelguertel ();
	break;

    case 10:
	WglToggleTouchline ();
	break;

    case 11:
	WglToggleErzeugende ();
	break;

    case 12:
	WglToggleInfo ();
	break;

    case 13:
	WglExit ();
	break;
    }
}

void
WglToggleTorkeln (void) {
      if(options.tork) {
	  glutChangeToMenuEntry(1, "<t> Schweben ein", 1);
      }
      else {
	  glutChangeToMenuEntry(1, "<t> Schweben aus", 1);
      }
      options.tork = ! options.tork;
}

void
WglToggleVirtuell (void) {
      if(options.virtuell) {
	  glutChangeToMenuEntry(2, "<e> Virtuelle Ecken ein", 2);
      }
      else {
	  glutChangeToMenuEntry(2, "<e> Virtuelle Ecken aus", 2);
      }
      options.virtuell = ! options.virtuell;
}

void
WglToggleAxis (void) {
      if(options.ach) {
	  glutChangeToMenuEntry(3, "<a> Achsen ein", 3);
      }
      else {
	  glutChangeToMenuEntry(3, "<a> Achsen aus", 3);
      }
      options.ach = ! options.ach;
}

void
WglTogglePerspektive (void) {
      if(options.perspektive) {
	  glutChangeToMenuEntry(4, "<p> Projektion perspektivisch", 4);
      }
      else {
	  glutChangeToMenuEntry(4, "<p> Projektion orthogonal", 4);
      }
      options.perspektive = ! options.perspektive;
      WglReshape (options.seite, options.seite);
}

void
WglToggleGitterFlaechen (void) {
      if(options.lines) {
	  glutChangeToMenuEntry(5, "<g> Gitter", 5);
      }
      else {
	  glutChangeToMenuEntry(5, "<g> Flaechen", 5);
      }
      options.lines = ! options.lines;
      if (polygonMode == GL_LINE) {
	  polygonMode = GL_FILL;
      }
      else {
	  polygonMode = GL_LINE;
      }
      glPolygonMode (GL_FRONT_AND_BACK, polygonMode);
}

void
WglToggleLabels (void) {
      if(options.labels) {
	  glutChangeToMenuEntry(6, "<l> Labels ein", 6);
      }
      else {
	  glutChangeToMenuEntry(6, "<l> Labels aus", 6);
      }
      options.labels = ! options.labels;
      WglCreateDisplayLists ();
}

void
WglToggleKuboid (void) {
      if(options.kuboid) {
	  options.kuboid = FALSE;
	  glutChangeToMenuEntry(7, "<k> Kuboid ein", 7);
      }
      else {
          options.kuboid = TRUE;
	  glutChangeToMenuEntry(7, "<k> Kuboid aus", 7);
      }
      if(options.oloid) {
	  options.oloid = FALSE;
	  glutChangeToMenuEntry(8, "<o> Oloid ein", 8);
      }
      else {
          options.oloid = TRUE;
	  glutChangeToMenuEntry(8, "<o> Oloid aus", 8);
      }
      WglCreateDisplayLists ();
}

void
WglToggleOloid (void) {
      if(options.oloid) {
	  options.oloid = FALSE;
	  glutChangeToMenuEntry(8, "<o> Oloid ein", 8);
      }
      else {
          options.oloid = TRUE;
	  glutChangeToMenuEntry(8, "<o> Oloid aus", 8);
      }
      if(options.kuboid) {
	  options.kuboid = FALSE;
	  glutChangeToMenuEntry(7, "<k> Kuboid ein", 7);
      }
      else {
          options.kuboid = TRUE;
	  glutChangeToMenuEntry(7, "<k> Kuboid aus", 7);
      }
      WglCreateDisplayLists ();
}

void
WglToggleWuerfelguertel (void) {
      if(options.wuerfel) {
	  glutChangeToMenuEntry(9, "<w> Wuerfelguertel ein", 9);
      }
      else {
	  glutChangeToMenuEntry(9, "<w> Wuerfelguertel aus", 9);
      }
      options.wuerfel = ! options.wuerfel;
}

void
WglToggleTouchline (void) {
      if(options.touchline) {
	  glutChangeToMenuEntry(10, "<b> Berhrungslinie ein", 10);
      }
      else {
	  glutChangeToMenuEntry(10, "<b> Berhrungslinie aus", 10);
      }
      options.touchline = ! options.touchline;
      WglCreateDisplayLists ();
}

void
WglToggleErzeugende (void) {
      if(options.erzeugende) {
	  glutChangeToMenuEntry(11, "<e> Erzeugende ein", 11);
      }
      else {
	  glutChangeToMenuEntry(11, "<e> Erzeugende aus", 11);
      }
      options.erzeugende = ! options.erzeugende;
      WglCreateDisplayLists ();
}
void
WglToggleInfo (void) {
      if(options.info) {
	  glutChangeToMenuEntry(12, "<i> Info ein", 11);
      }
      else {
	  glutChangeToMenuEntry(12, "<i> Info aus", 11);
      }
      glutSetWindow (winIdSub);
      if (options.info) {
          glutHideWindow();
      }
      else {
          glutShowWindow();
      }
      options.info = ! options.info;
}

void
WglExit (void) {
    exit (1);
}
